#!/usr/bin/env node
const { execSync } = require("child_process");
const runCommand = (command) => {
  try {
    execSync(`${command}`, { stdio: "inherit" });
  } catch (e) {
    console.error(`Failed to execute ${command}`, e);
    return false;
  }
  return true;
};
console.log(process.argv)
const repoName = process.argv[2] || "create-react-node";
const gitCheckout = `git clone --depth 1 https://github.com/sbendalam/node-react-starterkit ${repoName}`;
const installDeps = `cd ${repoName} && npm run install-all`;
console.log(`cloning the repo with name ${repoName}`);
const checkedOut = runCommand(gitCheckout);
if (!checkedOut) process.exit(-1);
console.log(`installing dependencies using npm run install-all`);
const installedDeps = runCommand(installDeps);
if (!installedDeps) process.exit(-1);
console.log(
  "You are ready. Follow the below command to start development server"
);
console.log(`cd ${repoName} && npm run start-mon`);
